%define anolis_release 1
%global xfceversion 4.16

%bcond_with perl

Name:           xfconf
Version:        4.16.0
Release: %{anolis_release}%{dist}
Summary:        Hierarchical configuration system for Xfce

License:        GPLv2
URL:            http://www.xfce.org/
#VCS git:git://git.xfce.org/xfce/xfconf
Source0:        http://archive.xfce.org/src/xfce/%{name}/%{xfceversion}/%{name}-%{version}.tar.bz2

BuildRequires:  make
BuildRequires:  glib2-devel
BuildRequires:  pkgconfig(libxfce4util-1.0) >= %{xfceversion}
BuildRequires:  pkgconfig(dbus-1) >= 1.1.0
BuildRequires:  pkgconfig(dbus-glib-1) >= 0.84
%if %{with perl}
BuildRequires:  perl-devel
BuildRequires:  perl-generators
BuildRequires:  perl(ExtUtils::Depends)
BuildRequires:  perl(ExtUtils::PkgConfig)
BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  perl(Glib)
BuildRequires:  perl(Glib::MakeHelper)
%endif
BuildRequires:  gettext
BuildRequires:  intltool
BuildRequires:  gcc-c++
BuildRequires:  gobject-introspection-devel
BuildRequires:  vala

Requires:       dbus

Obsoletes:      libxfce4mcs < 4.4.3-3
Obsoletes:      xfconf-perl < 4.13.8

%description
Xfconf is a hierarchical (tree-like) configuration system where the
immediate child nodes of the root are called "channels".  All settings
beneath the channel nodes are called "properties."

%package        devel
Summary:        Development tools for xfconf
Requires:       %{name} = %{version}-%{release}
Requires:       pkgconfig
Requires:       dbus-devel
Requires:       dbus-glib-devel
Requires:       glib2-devel
Obsoletes:      libxfce4mcs-devel < 4.4.3-3
Obsoletes:      xfce-mcs-manager-devel < 4.4.3-3

%description devel
This package includes the libraries and header files you will need
to compile applications for xfconf.

%if %{with perl}
%package perl
Summary:        Perl modules for xfconf
Requires:       %{name} = %{version}-%{release}
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description perl
This package includes the perl modules and files you will need to 
interact with xfconf using perl. 
%endif

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q

%build
%configure --disable-static --with-perl-options=INSTALLDIRS="vendor"
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
export LD_LIBRARY_PATH="`pwd`/xfconf/.libs"

%make_build

%install
%make_install

# fix permissions for installed libraries
chmod 755 %{buildroot}/%{_libdir}/*.so

%if %{with perl}
# remove perl temp file
rm -f %{buildroot}/%{perl_archlib}/perllocal.pod

# remove unneeded dynloader bootstrap file
rm -f %{buildroot}/%{perl_vendorarch}/auto/Xfce4/Xfconf/Xfconf.bs

# fix permissions on the .so file
chmod 755 %{buildroot}/%{perl_vendorarch}/auto/Xfce4/Xfconf/Xfconf.so
%endif

# remove .packlist files. 
find %{buildroot} -type f -name .packlist -exec rm -f {} \;

# get rid of .la files
find %{buildroot} -type f -name *.la -exec rm -f {} \;

%find_lang %{name}

%generate_compatibility_deps

%files -f %{name}.lang
%license COPYING
%{_libdir}/lib*.so.*
%{_bindir}/xfconf-query
%{_libdir}/xfce4/xfconf/
%{_libdir}/girepository-1.0/Xfconf-0.typelib
%{_datadir}/vala/vapi/libxfconf-0.deps
%{_datadir}/vala/vapi/libxfconf-0.vapi
%{_datadir}/dbus-1/services/org.xfce.Xfconf.service
%{_datadir}/gir-1.0/Xfconf-0.gir
%{_datadir}/bash-completion/completions/xfconf-query

%dir %{abidir}
%{abidir}/lib*.dump
%{abidir}/xfconf-query-option.list

%files devel
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/xfce4/xfconf-0
%{_libdir}/gio/modules/libxfconfgsettingsbackend.so
%{abidir}/libxfconfgsettingsbackend.dump

%if %{with perl}
%files perl
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/Xfce4
%{_mandir}/man3/*.3*
%endif

%files doc
%doc %{_datadir}/gtk-doc
%doc ChangeLog README.md AUTHORS NEWS TODO

%changelog
* Mon Mar 20 2023 Zhongling He <zhonglingh@linux.alibaba.com> - 4.16.0-1
- Init package from upstream
